#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#ifdef MAC
#include <console.h>
#endif
#include "clustalw.h"
#include "slaves.h"
#ifdef MAC
extern int ccommand(char ***);
#endif

#include <mpi.h>

/*
*	Global variables
*/

OPT opt;

void main(int argc,char **argv)
{
  MPI_Status status;
  int id_process;

  MPI_Init(&argc,&argv);
  MPI_Comm_rank(MPI_COMM_WORLD,&id_process);

  if(id_process==0)
    {
      main_process_master(argc,argv);
    }
  else
    {
      main_processes_slaves(argc,argv);
    }
  MPI_Finalize();
}


int main_process_master(int argc,char **argv)
{
	sint i;
	char **args;
	ALN mult_aln;
	char revision_level[] = "(0.1)";  /* JULIE  sept 1998 */
	sint parse_params_return;

#ifdef MSDOS
        char *help_file_name = "clustalw.hlp";
#else
        char *help_file_name = "clustalw_help";
#endif
	
#ifdef MAC
	argc=ccommand(&argv);
#endif
	set_revision_level(revision_level);
	set_help_file_name(help_file_name);

/* initialisation - if any modules require some initialisation include a function
   init_*() and call it here */

	init_options(&opt);
	mult_aln.nseqs=0;
	mult_aln.nanchors=0;
	mult_aln.dnaflag=FALSE;
	strcpy(mult_aln.alphabet,"ABCDEFGHIJKLMNOPQRSTUVWXYZ");
	mult_aln.prf1.nseqs=0;
	mult_aln.prf2.nseqs=0;
	mult_aln.treename[0]='\0';
	mult_aln.prf1.treename[0]='\0';
	mult_aln.prf2.treename[0]='\0';

	if(argc>1) {
	  args = (char **)ckalloc(argc * sizeof(char *));
	
	  for(i=0;i<argc-1;i++) 
	    {
	      args[i]=(char *)ckalloc((strlen(argv[i+1])+1) * sizeof(char));
	      strcpy(args[i],argv[i+1]);
	    }
	  fprintf(stdout,"\n\n\n");
	  fprintf(stdout," LeClustal %s Multiple Sequence Alignments\n\n\n",revision_level);
	  parse_params_return=parse_params(FALSE,args,&opt,&mult_aln,FALSE);
	  
	  if(parse_params_return!=NOW_GO_HOME)
	    {
	      for(i=0;i<argc-1;i++) 
		ckfree(args[i]);
	      ckfree(args);
	    }
	}

/* a special flag to tell everybody that we're using the clustalw text menus */
	/*	if(parse_params_return!=NOW_GO_HOME)
		{
		set_usemenu(TRUE);
		main_menu(&opt,mult_aln,revision_level);
		}*/
	return 0;
}

