#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <vibrant.h>

#include "clustalw.h"
#include "xmenu.h"

/*
*	Global variables
*/


OPT opt;

extern Int2 Main(void)
 
{
	int i;
	char **args;
	ALN mult_aln;
	char revision_level[] = "(0.1)";  /* JULIE  may 1996 */
#ifdef MSDOS
        char *help_file_name = "clustalx.hlp";
#else
        char *help_file_name = "clustalx_help";
#endif
 


#ifndef WIN_MAC
#ifdef GetArgc
	int argc;
	char **argv;
	
	argc=GetArgc();
	argv=GetArgv();
#else
	extern int argc;
	extern char **argv;
#endif
#endif
	set_revision_level(revision_level);
	set_help_file_name(help_file_name);

/* initialisation - if any modules require some initialisation include a function
   init_*() and call it here */

	init_options(&opt);
	mult_aln.nseqs=0;
	mult_aln.nanchors=0;
	mult_aln.filename[0]='\0';
	mult_aln.treename[0]='\0';
	mult_aln.dnaflag=0;
	strcpy(mult_aln.alphabet,"ABCDEFGHIJKLMNOPQRSTUVWXYZ");
	mult_aln.prf1.nseqs=0;
	mult_aln.prf1.filename[0]='\0';
	mult_aln.prf1.treename[0]='\0';
	mult_aln.prf2.nseqs=0;
	mult_aln.prf2.filename[0]='\0';
	mult_aln.prf2.treename[0]='\0';

#ifndef WIN_MAC
	if(argc>1) {
               args = (char **)ckalloc(argc * sizeof(char *));

                for(i=0;i<argc-1;i++)
                {
                        args[i]=(char *)ckalloc((strlen(argv[i+1])+1) * sizeof(char));
                        strcpy(args[i],argv[i+1]);
                }
                parse_params(TRUE,args,&opt,&mult_aln,TRUE);

                for(i=0;i<argc-1;i++)
                        ckfree(args[i]);
                ckfree(args);

	}
#endif
	x_menu(opt,mult_aln,revision_level);
	
	return 0;
}

