typedef struct {
  int si;
  int sj;
  double tmat;
}TMAT_SI_SJ;

/*
*	Prototypes
*/
static float forward_pass(char *seq1, char *seq2, sint n, sint m,sint gop, sint gep,  
			  COMP_MATRIX matrix);
static float forward_passmotif(char *seq1, char *seq2, sint n, sint m,sint gop, sint gep,  COMP_MATRIX matrix,
			       sint **motif_score,Boolean add_motif);

/*alignment of the pairs number alnstart to alnstop*/

void subpairalign(ALN mult_aln,sint alnstart,sint alnstop,TMAT_SI_SJ *tmat_si_sj,PW_OPT pw_opt,
		  MOTIF *motifs,sint nseqs,COMP_MATRIX matrix,sint int_scale,float gop_scale,
		  float gep_scale);

/*************************************/
/*                                   */
/*Update of si and sj in subpairalign*/
/*                                   */
/*************************************/

void si_sj_update(int inseq,int jstart,int *si,int *sj);

/***********************************************************************/
/*                                                                     */
/*Procedure which seeks the si and sj for which tmat must be calculated*/
/*                                                                     */
/***********************************************************************/

void seek_si_sj_to_calculate(int istart,int inseq,int jstart,int jnseq,int alnstart,
			     int alnstop,TMAT_SI_SJ *tmat_si_sj);
