#include <stdio.h>
#include <stdarg.h>
#include <string.h>
 
#include <vibrant.h>
 
#include "clustalw.h"
#include "xmenu.h"

static int get_series_matrixname(char *usermtrxname, int usermatnum,int *matnum,PrompT mattext);
extern ALN mult_aln;
extern OPT opt;
extern spanel  active_panel;
extern Boolean xmenus_active;
extern WindoW mainw;
extern GrouP matrix_list,pw_matrix_list;
extern GrouP dnamatrix_list,pw_dnamatrix_list;
extern GrouP seg_matrix_list,seg_dnamatrix_list;
extern GrouP score_matrix_list,score_dnamatrix_list;
extern Boolean  realign_endgappenalties;
extern Boolean  align_endgappenalties;
extern Boolean  save_log;
extern Boolean  save_parameters;
extern int inverted;

extern MatMenu matrix_menu;
extern MatMenu dnamatrix_menu;
extern MatMenu pw_matrix_menu;

extern TexT savealntext;
extern GrouP slow_para,fast_para;

extern PrompT   message;           /* used in temporary message window */
extern Boolean mess_output;
extern FILE *save_log_fd;
extern spanel  seq_panel;        /* data for multiple alignment area */
extern spanel  prf_panel[];       /* data for profile alignment areas */
extern Boolean aln_mode;
extern Boolean fixed_prf_scroll;
extern Boolean output_ss;
extern Boolean output_gp;
extern PrompT mattext,pwmattext,motiftext;
extern PrompT dnamattext,pwdnamattext;
extern int    save_format;
extern Boolean residue_exceptions;
extern Boolean segment_exceptions;
extern int font_size;
extern FonT datafont;
extern int av_font[];
extern TexT blocklentext;

extern int      pagesize;
extern int      orientation;
extern Boolean  ps_ruler,ps_header,resize,ps_curve,ps_resno;
extern int      first_printres,last_printres,blocklen;
extern int      firstres,lastres;



void set_go_penalty(TexT t)
{
	char str[10];
	float temp;
	panel_data data;

	GetPanelExtra(active_panel.seqs,&data);

	GetTitle(t,str,10);
	temp = atof(str);
	if (temp < 0 || temp > 100)
		return;

        if(mult_aln.dnaflag)
         	(*opt.mult_opt).dna_gap_open     = temp;
	else
         	(*opt.mult_opt).prot_gap_open     = temp;
}

void set_ge_penalty(TexT t)
{
	char str[10];
	float temp;
	panel_data data;

	GetPanelExtra(active_panel.seqs,&data);

	GetTitle(t,str,10);
	temp = atof(str);
	if (temp < 0 || temp > 100)
		return;

        if(mult_aln.dnaflag)
         	(*opt.mult_opt).dna_gap_extend     = temp;
	else
         	(*opt.mult_opt).prot_gap_extend     = temp;
}

void set_gap_dist(TexT t)
{
	char str[10];
	int temp;

	GetTitle(t,str,10);
	temp = atoi(str);
	if (temp < 0 || temp > 100)
		return;
	(*opt.mult_opt->gap_opt).gap_dist = temp;

}

void set_ntrials(TexT t)
{
        char str[10];
        int temp;
 
        GetTitle(t,str,10);
	if (str == NULL) return;
	temp = atoi(str);
        if (temp < 0 || temp > 10000)
                return;
        (*opt.bstree_opt).boot_ntrials = temp;
}

void set_ran_seed(TexT t)
{
        char str[10];
        int temp;
 
        GetTitle(t,str,10);
        temp = atoi(str);
        if (temp < 0 || temp > 1000)
                return;
        (*opt.bstree_opt).boot_ran_seed = temp;
}

void set_div_seq(TexT t)
{
	char str[10];
	int temp;

	GetTitle(t,str,10);
	temp = atoi(str);
	if (temp < 0 || temp > 100)
		return;
	(*opt.mult_opt).divergence_cutoff = temp;
}

void set_pw_go_penalty(TexT t)
{
        char str[10];
        float temp;
	panel_data data;

	GetPanelExtra(active_panel.seqs,&data);
 
        GetTitle(t,str,10);
        temp = atof(str);
        if (temp < 0 || temp > 100)
                return;

        if(mult_aln.dnaflag)
         	opt.pw_opt->dna_go_penalty     = temp;
	else
         	opt.pw_opt->prot_go_penalty     = temp;
}

void set_pw_ge_penalty(TexT t)
{
        char str[10];
        float temp;
	panel_data data;

	GetPanelExtra(active_panel.seqs,&data);
 
        GetTitle(t,str,10);
        temp = atof(str);
        if (temp < 0 || temp > 100)
                return;

        if(mult_aln.dnaflag)
         	opt.pw_opt->dna_ge_penalty     = temp;
	else
         	opt.pw_opt->prot_ge_penalty     = temp;
}

void set_gp(TexT t)
{
        char str[10];
        int temp;
	panel_data data;

	GetPanelExtra(active_panel.seqs,&data);
 
        GetTitle(t,str,10);
        temp = atoi(str);
        if (temp < 0 || temp > 100)
                return;

        if(mult_aln.dnaflag)
         	opt.quickpw_opt->dna_wind_gap       = temp;
	else
         	opt.quickpw_opt->prot_wind_gap       = temp;
}

void set_ktuple(TexT t)
{
        char str[10];
        int temp;
	panel_data data;

	GetPanelExtra(active_panel.seqs,&data);
 
        GetTitle(t,str,10);
        temp = atoi(str);
        if (temp < 0 || temp > 100)
                return;

        if(mult_aln.dnaflag)
         	opt.quickpw_opt->dna_ktup       = temp;
	else
         	opt.quickpw_opt->prot_ktup       = temp;
}

void set_topdiags(TexT t)
{
        char str[10];
        int temp;
	panel_data data;

	GetPanelExtra(active_panel.seqs,&data);
 
        GetTitle(t,str,10);
        temp = atoi(str);
        if (temp < 0 || temp > 100)
                return;

        if(mult_aln.dnaflag)
         	opt.quickpw_opt->dna_signif     = temp;
	else
         	opt.quickpw_opt->prot_signif     = temp;
}

void set_window(TexT t)
{
        char str[10];
        int temp;
	panel_data data;

	GetPanelExtra(active_panel.seqs,&data);
 
        GetTitle(t,str,10);
        temp = atoi(str);
        if (temp < 0 || temp > 100)
                return;

        if(mult_aln.dnaflag)
         	opt.quickpw_opt->dna_window     = temp;
	else
         	opt.quickpw_opt->prot_window     = temp;
}

void set_hyd_res(TexT t)
{
	int i,j;
	char tstr[27];

	GetTitle(t,tstr,27);
	for (i=0,j=0;i<strlen((*opt.mult_opt->gap_opt).hyd_residues) && i<27;i++)
	{
		if (isalpha(tstr[i]))
			(*opt.mult_opt->gap_opt).hyd_residues[j++] = tstr[i];
	}
	(*opt.mult_opt->gap_opt).hyd_residues[j]='\0';
}

void set_button(ButtoN l,Boolean *value)
{
	int tmp;

	tmp = GetStatus(l);
	if (tmp == TRUE)
		*value = TRUE;
	else
		*value = FALSE;
}

void set_toggle(PopuP l,Boolean *value)
{
	int tmp;

	tmp = GetValue(l);
	if (tmp == 1)
		*value = TRUE;
	else
		*value = FALSE;
}

void set_pref_penalties(PopuP l)
{
	set_toggle(l,&(*opt.mult_opt->gap_opt).no_pref_penalties);
}

void set_hyd_penalties(PopuP l)
{
	set_toggle(l,&(*opt.mult_opt->gap_opt).no_hyd_penalties);
}
void set_var_penalties(PopuP l)
{
	set_toggle(l,&(*opt.mult_opt->gap_opt).no_var_penalties);
}
void set_endgaps(PopuP l)
{
	set_toggle(l,&(*opt.mult_opt->gap_opt).use_endgaps);
}
void set_align_endgappenalties(PopuP l)
{
	set_toggle(l,&align_endgappenalties);
}
void set_realign_endgappenalties(PopuP l)
{
	set_toggle(l,&realign_endgappenalties);
}
void set_case(PopuP l)
{
	set_toggle(l,&(*opt.alnout_opt).lowercase);
}
void set_snos(PopuP l)
{
	set_toggle(l,&(*opt.alnout_opt).seq_numbers);
}
void set_save_paras(PopuP l)
{
	set_toggle(l,&save_parameters);
}
void set_transitions(TexT t)
{
        char str[10];
        float temp;
 
        GetTitle(t,str,10);
        temp = atof(str);
        if (temp < 0 || temp > 100)
                return;
 
        (*opt.mult_opt).transition_weight = temp;
}

void set_ambiguities(PopuP l)
{
	set_toggle(l,&(*opt.tree_opt).use_ambiguities);
}

void set_use_motifs(PopuP l)
{
	set_toggle(l,&(*opt.mult_opt).use_motifs);
}

void set_motif_file(ButtoN but)
{
	static Char filename[FILENAMELEN];

        if (GetInputFileName(filename,FILENAMELEN,"","")) 
	{
                strcpy(opt.mult_opt->motif_filename,filename);
		SetTitle(motiftext,filename);
	} 
}

void set_neg_matrix(PopuP l)
{
	set_toggle(l,&(*opt.mult_opt).neg_matrix);
}

void set_output_nbrf(ButtoN l)
{
	set_button(l,&(*opt.alnout_opt).output_nbrf);
}
void set_output_phylip(ButtoN l)
{
	set_button(l,&(*opt.alnout_opt).output_phylip);
}
void set_output_gcg(ButtoN l)
{
	set_button(l,&(*opt.alnout_opt).output_gcg);
}

void set_treealgo(PopuP g)
{
	int tmp;
	tmp = GetValue(g);
	if (tmp == 1)
		(*opt.pw_opt).treealgo=NJ;
	else
		(*opt.pw_opt).treealgo=BIONJ;
}

void set_output_order(PopuP g)
{
	int tmp;
	tmp = GetValue(g);
	if (tmp == 1)
		(*opt.alnout_opt).output_order=INPUT;
	else
		(*opt.alnout_opt).output_order=ALIGNED;
}

void set_pagesize(PopuP g)
{
	int tmp;
	char tstr[10];

	tmp = GetValue(g);
	if (tmp == 1)
		pagesize=A4;
	else
		pagesize=A3;
	if(orientation==LANDSCAPE)
	{
		if(pagesize==A4) blocklen=150;
		else blocklen=250;
	}
	else
	{
		if(pagesize==A4) blocklen=80;
		else blocklen=150;
	}
	sprintf(tstr,"%d",blocklen);
	SetTitle(blocklentext,tstr);
}
void set_orientation(PopuP g)
{
	int tmp;
	char tstr[10];

	tmp = GetValue(g);
	if (tmp == 1)
		orientation=LANDSCAPE;
	else
		orientation=PORTRAIT;

	if(orientation==LANDSCAPE)
	{
		if(pagesize==A4) blocklen=150;
		else blocklen=250;
	}
	else
	{
		if(pagesize==A4) blocklen=80;
		else blocklen=150;
	}
	sprintf(tstr,"%d",blocklen);
	SetTitle(blocklentext,tstr);
}
void set_resno(PopuP l)
{
	set_toggle(l,&ps_resno);
}
void set_curve(PopuP l)
{
	set_toggle(l,&ps_curve);
}
void set_ruler(PopuP l)
{
	set_toggle(l,&ps_ruler);
}
void set_header(PopuP l)
{
	set_toggle(l,&ps_header);
}
void set_resize(PopuP l)
{
	set_toggle(l,&resize);
}
void set_fres(TexT t)
{
        char str[10];
        int temp;
 
        GetTitle(t,str,10);
	if (str == NULL) return;
	temp = atoi(str);
        if (temp < 0 || temp > 100000)
                return;
        firstres = temp;
}
void set_lres(TexT t)
{
        char str[10];
        int temp;
 
        GetTitle(t,str,10);
	if (str == NULL) return;
	temp = atoi(str);
        if (temp < 0 || temp > 100000)
                return;
        lastres = temp;
}
void set_fpres(TexT t)
{
        char str[10];
        int temp;
 
        GetTitle(t,str,10);
	if (str == NULL) return;
	temp = atoi(str);
        if (temp < 0 || temp > 10000)
                return;
        first_printres = temp;
}
void set_lpres(TexT t)
{
        char str[10];
        int temp;
 
        GetTitle(t,str,10);
	if (str == NULL) return;
	temp = atoi(str);
        if (temp < 0 || temp > 10000)
                return;
        last_printres = temp;
}
void set_blocklen(TexT t)
{
        char str[10];
        int temp;
 
        GetTitle(t,str,10);
	if (str == NULL) return;
	temp = atoi(str);
        if (temp < 0 || temp > 10000)
                return;
        blocklen = temp;
}
void set_output_tree_clustal(ButtoN l)
{
	set_button(l,&(*opt.tree_opt).output_tree_clustal);
}
void set_output_tree_phylip(ButtoN l)
{
	set_button(l,&(*opt.tree_opt).output_tree_phylip);
}
void set_output_tree_distances(ButtoN l)
{
	set_button(l,&(*opt.tree_opt).output_tree_distances);
}
void set_output_tree_bionj(ButtoN l)
{
	set_button(l,&(*opt.tree_opt).output_tree_bionj);
}
void set_output_tree_nexus(ButtoN l)
{
	set_button(l,&(*opt.tree_opt).output_tree_nexus);
}
void set_tossgaps(IteM i)
{
	(*opt.tree_opt).tossgaps=GetStatus(i);
}
void set_kimura(IteM i)
{
	(*opt.tree_opt).kimura=GetStatus(i);
}
void set_boot_format(PopuP g)
{
	int tmp;
	tmp = GetValue(g);
	if (tmp == 1)
		(*opt.bstree_opt).bootstrap_format=BS_NODE_LABELS;
	else
		(*opt.bstree_opt).bootstrap_format=BS_BRANCH_LABELS;
}

char prompt_for_yes_no(char *title,char *prompt)
{
        char lin2[MESSLENGTH*MESSLINES];
 
	if(!xmenus_active) return('y');

	strcpy(lin2,title);
	strcat(lin2,".\n");
	strcat(lin2,prompt);
	strcat(lin2,"?");
	if (Message(MSG_YN,lin2)==ANS_NO)
                return('n');
        else
                return('y');
 
}
 

/*
*	fatal()
*
*	Prints error msg and exits.
*	Variadic parameter list can be passed.
*
*	Return values:
*		none
*/

void fatal( char *msg,...)
{
	va_list ap;
	char istr[MESSLENGTH*MESSLINES] = "FATAL ERROR: ";
	char vstr[1000];

	
	va_start(ap,msg);
	vsprintf(vstr,msg,ap);
	va_end(ap);
	strncat(istr,vstr,MESSLENGTH*MESSLINES-20);
	Message(MSG_FATAL,istr);
}

/*
*	error()
*
*	Prints error msg.
*	Variadic parameter list can be passed.
*
*	Return values:
*		none
*/

void error( char *msg,...)
{
	va_list ap;
	char istr[MESSLENGTH*MESSLINES] = "ERROR: ";
	char vstr[1000];

	
	va_start(ap,msg);
	vsprintf(vstr,msg,ap);
	va_end(ap);
	strncat(istr,vstr,MESSLENGTH*MESSLINES-10);
	if (!xmenus_active)
		fprintf(stdout,"%s",istr);
	else
		Message(MSG_ERROR,istr);
}

/*
*	warning()
*
*	Prints warning msg.
*	Variadic parameter list can be passed.
*
*	Return values:
*		none
*/

void warning( char *msg,...)
{
	va_list ap;
	char istr[MESSLENGTH*MESSLINES] = "WARNING: ";
	char vstr[1000];

	
	va_start(ap,msg);
	vsprintf(vstr,msg,ap);
	va_end(ap);
	strncat(istr,vstr,MESSLENGTH*MESSLINES-10);
	if (!xmenus_active)
		fprintf(stdout,"%s",istr);
	else
		Message(MSG_ERROR,istr);
}

/*
*	info()
*
*	Prints info msg.
*	Variadic parameter list can be passed.
*
*	Return values:
*		none
*/

void info( char *msg,...)
{
	va_list ap;
	char istr[MESSLENGTH+10] = "";
	char vstr[1000];
    
	if (!mess_output) return;

	va_start(ap,msg);
	vsprintf(vstr,msg,ap);
	va_end(ap);
	strncat(istr,vstr,MESSLENGTH);
	if (!xmenus_active)
		fprintf(stdout,"%s\n",istr);
	else
	{
		UseWindow(mainw);
		SelectFont(systemFont);	
		SetTitle(message,istr);
		if(save_log && save_log_fd!=NULL)
			fprintf(save_log_fd,"%s\n",istr);
		Update();
	}

}


void set_helix_gp(TexT t)
{
	char str[10];
	int temp;

	GetTitle(t,str,10);
	temp = atoi(str);
	if (temp < 0 || temp > 9)
		return;
	(*opt.ss_opt).helix_penalty = temp;

}

void set_strand_gp(TexT t)
{
	char str[10];
	int temp;

	GetTitle(t,str,10);
	temp = atoi(str);
	if (temp < 0 || temp > 9)
		return;
	(*opt.ss_opt).strand_penalty = temp;

}

void set_loop_gp(TexT t)
{
	char str[10];
	int temp;

	GetTitle(t,str,10);
	temp = atoi(str);
	if (temp < 0 || temp > 9)
		return;
	(*opt.ss_opt).loop_penalty = temp;

}

void set_terminal_gp(TexT t)
{
	char str[10];
	int temp;

	GetTitle(t,str,10);
	temp = atoi(str);
	if (temp < 0 || temp > 9)
		return;
	(*opt.ss_opt).helix_end_penalty = temp;

}

void set_helix_minus(TexT t)
{
	char str[10];
	int temp;

	GetTitle(t,str,10);
	temp = atoi(str);
	if (temp < 0 || temp > 9)
		return;
	(*opt.ss_opt).helix_end_minus = temp;

}

void set_helix_plus(TexT t)
{
	char str[10];
	int temp;

	GetTitle(t,str,10);
	temp = atoi(str);
	if (temp < 0 || temp > 9)
		return;
	(*opt.ss_opt).helix_end_plus = temp;
}

void set_strand_plus(TexT t)
{
	char str[10];
	int temp;

	GetTitle(t,str,10);
	temp = atoi(str);
	if (temp < 0 || temp > 9)
		return;
	(*opt.ss_opt).strand_end_plus = temp;
}

void set_strand_minus(TexT t)
{
	char str[10];
	int temp;

	GetTitle(t,str,10);
	temp = atoi(str);
	if (temp < 0 || temp > 9)
		return;
	(*opt.ss_opt).strand_end_minus = temp;
}

 
void set_ss_output(ButtoN b)
{
        int tmp;
 
        tmp = GetStatus(b);
        if (tmp) output_ss = TRUE;
	else output_ss = FALSE;

	if (output_ss && output_gp)
		(*opt.ss_opt).output_struct_penalties=2;
	else if (output_ss)
		(*opt.ss_opt).output_struct_penalties=0;
	else if (output_gp)
		(*opt.ss_opt).output_struct_penalties=1;
	else
		(*opt.ss_opt).output_struct_penalties=3;
}
void set_gp_output(ButtoN b)
{
        int tmp;
 
        tmp = GetStatus(b);
        if (tmp) output_gp = TRUE;
	else output_gp = FALSE;

	if (output_ss && output_gp)
		(*opt.ss_opt).output_struct_penalties=2;
	else if (output_ss)
		(*opt.ss_opt).output_struct_penalties=0;
	else if (output_gp)
		(*opt.ss_opt).output_struct_penalties=1;
	else
		(*opt.ss_opt).output_struct_penalties=3;
}

void set_user_matrix(ButtoN but)
{
	if(get_series_matrixname((*opt.mult_opt).usermtrxname,5,&(*opt.mult_opt).matnum,mattext))
		strcpy((*opt.mult_opt).mtrxname,(*opt.mult_opt).usermtrxname);
	SetValue(matrix_list,(*opt.mult_opt).matnum);
}


void set_pw_user_matrix(ButtoN but)
{
	if(get_user_matrixname(opt.pw_opt->usermtrxname,5,&opt.pw_opt->matnum,pwmattext))
		strcpy(opt.pw_opt->mtrxname,opt.pw_opt->usermtrxname);
	SetValue(pw_matrix_list,opt.pw_opt->matnum);
}

void set_pw_matrix(GrouP g)
{
        int tmp;
 
        tmp = GetValue(g);
        if (tmp>0 && tmp<pw_matrix_menu.noptions) 
        {
                opt.pw_opt->matnum = tmp;
		strcpy(opt.pw_opt->mtrxname,pw_matrix_menu.opt[tmp-1].string);
        }
        else if(opt.pw_opt->usermtrxname[0]=='\0')
	{
		if(get_user_matrixname(opt.pw_opt->usermtrxname,pw_matrix_menu.noptions,&opt.pw_opt->matnum,pwmattext))
			strcpy(opt.pw_opt->mtrxname,opt.pw_opt->usermtrxname);
	}
	else
		opt.pw_opt->matnum=pw_matrix_menu.noptions;
	SetValue(pw_matrix_list,opt.pw_opt->matnum);
}
void set_matrix(GrouP g)
{
	int tmp;
 
        tmp = GetValue(g);
        if (tmp>0 && tmp<matrix_menu.noptions) 
        {
        	(*opt.mult_opt).matnum = tmp;
		strcpy((*opt.mult_opt).mtrxname,matrix_menu.opt[tmp-1].string);
        }
        else if((*opt.mult_opt).usermtrxname[0]=='\0')
	{
		if(get_series_matrixname((*opt.mult_opt).usermtrxname,matrix_menu.noptions,&(*opt.mult_opt).matnum,mattext))
			strcpy((*opt.mult_opt).mtrxname,(*opt.mult_opt).usermtrxname);
	}
	else (*opt.mult_opt).matnum=matrix_menu.noptions;

	SetValue(matrix_list,(*opt.mult_opt).matnum);
}

static int get_series_matrixname(char *usermtrxname, int usermatnum,int *matnum,PrompT text)
{
	int ret=0;
	static Char filename[FILENAMELEN];

        if (GetInputFileName(filename,FILENAMELEN,"","")) 
	{
        	if(check_user_matrix_series(filename,FALSE))
        	{
                	strcpy(usermtrxname,filename);
                	*matnum=usermatnum;
			SetTitle(text,usermtrxname);
			ret=1;
        	}
	} 

	return ret;
}
int get_user_matrixname(char *usermtrxname, int usermatnum,int *matnum,PrompT text)
{
	int ret=0;
	static Char filename[FILENAMELEN];

        if (GetInputFileName(filename,FILENAMELEN,"","")) 
	{
        	if(check_user_matrix(filename))
        	{
                	strcpy(usermtrxname,filename);
                	*matnum=usermatnum;
			SetTitle(text,usermtrxname);
			ret=1;
        	}
	} 

	return ret;
}

void set_user_dnamatrix(ButtoN but)
{
	if(get_user_matrixname((*opt.mult_opt).dnausermtrxname,3,&(*opt.mult_opt).dnamatnum,dnamattext))
		strcpy((*opt.mult_opt).dnamtrxname,(*opt.mult_opt).dnausermtrxname);
	SetValue(dnamatrix_list,(*opt.mult_opt).dnamatnum);
}


void set_pw_user_dnamatrix(ButtoN but)
{
	if(get_user_matrixname(opt.pw_opt->dnausermtrxname,3,&opt.pw_opt->dnamatnum,pwdnamattext))
		strcpy(opt.pw_opt->dnamtrxname,opt.pw_opt->dnausermtrxname);
	SetValue(pw_dnamatrix_list,opt.pw_opt->dnamatnum);
}

void set_pw_dnamatrix(GrouP g)
{
        int tmp;
 
        tmp = GetValue(g);
        if (tmp>0 && tmp<dnamatrix_menu.noptions) 
        {
                opt.pw_opt->dnamatnum = tmp;
		strcpy(opt.pw_opt->dnamtrxname,dnamatrix_menu.opt[tmp-1].string);
        }
        else if(opt.pw_opt->dnausermtrxname[0]=='\0')
	{
		if(get_user_matrixname(opt.pw_opt->dnausermtrxname,dnamatrix_menu.noptions,&opt.pw_opt->dnamatnum,pwdnamattext))
			strcpy(opt.pw_opt->dnamtrxname,opt.pw_opt->dnausermtrxname);
	}
	else opt.pw_opt->dnamatnum=dnamatrix_menu.noptions;
	SetValue(pw_dnamatrix_list,opt.pw_opt->dnamatnum);
}
void set_dnamatrix(GrouP g)
{
	int tmp;
 
        tmp = GetValue(g);
        if (tmp>0 && tmp<dnamatrix_menu.noptions) 
        {
        	(*opt.mult_opt).dnamatnum = tmp;
		strcpy((*opt.mult_opt).dnamtrxname,dnamatrix_menu.opt[tmp-1].string);
        }
        else if((*opt.mult_opt).dnausermtrxname[0]=='\0')
	{
		if(get_user_matrixname((*opt.mult_opt).dnausermtrxname,dnamatrix_menu.noptions,&(*opt.mult_opt).dnamatnum,dnamattext))
			strcpy((*opt.mult_opt).dnamtrxname,(*opt.mult_opt).dnausermtrxname);
	}
	else (*opt.mult_opt).dnamatnum=dnamatrix_menu.noptions;
	SetValue(dnamatrix_list,(*opt.mult_opt).dnamatnum);
}

FILE *  open_input_file(char *file_name)
{
        FILE * file_handle;
 
        if (*file_name == EOS) {
                error("Bad input file [%s]",file_name);
                return NULL;
        }
#ifdef VMS
        if((file_handle=fopen(file_name,"r","rat=cr","rfm=var"))==NULL) {
#else
        if((file_handle=fopen(file_name,"r"))==NULL) {
#endif
                error("Cannot open input file [%s]",file_name);
                return NULL;
        }
        return file_handle;
}

 
void set_use_ss1(PopuP l)
{
	panel_data data;

        set_toggle(l,&(*opt.ss_opt).use_ss1);
	GetPanelExtra(prf_panel[0].seqs,&data);

	load_aln(prf_panel[0],data.prf_no,0,mult_aln.prf1.nseqs,FALSE);
	load_aln(prf_panel[1],data.prf_no,mult_aln.prf1.nseqs,mult_aln.prf2.nseqs,FALSE);
}
void set_use_ss2(PopuP l)
{
	panel_data data;

        set_toggle(l,&(*opt.ss_opt).use_ss2);
	GetPanelExtra(prf_panel[0].seqs,&data);

	load_aln(prf_panel[0],data.prf_no,0,mult_aln.prf1.nseqs,FALSE);
	load_aln(prf_panel[1],data.prf_no,mult_aln.prf1.nseqs,mult_aln.prf2.nseqs,FALSE);
}


void set_output_clustal(ButtoN l)
{
        set_button(l,&(*opt.alnout_opt).output_clustal);
}
void set_output_gde(ButtoN l)
{
        set_button(l,&(*opt.alnout_opt).output_gde);
}
void set_output_nexus(ButtoN l)
{
        set_button(l,&(*opt.alnout_opt).output_nexus);
}

void set_format(GrouP g)
{
        int i;
	char path[FILENAMELEN];
	panel_data data;

	GetPanelExtra(seq_panel.seqs,&data);
	get_path(mult_aln.filename,path);
	GetTitle(savealntext, path,FILENAMELEN);
/* remove the current extension */
	for(i=strlen(path)-1;i>=0;i--)
		if(path[i]=='.')
		{
			path[i]='\0';
			break;
		}
			
        i = GetValue(g);
        if (i==1)
	{
                save_format=CLUSTAL;
		strcat(path,".aln");
	}
        else if (i==2)
	{
                save_format=PIR;
		strcat(path,".pir");
	}
        else if (i==3)
	{
                save_format=MSF;
		strcat(path,".msf");
	}
        else if (i==4)
	{
                save_format=PHYLIP;
		strcat(path,".phy");
	}
        else if (i==5)
	{
                save_format=GDE;
		strcat(path,".gde");
	}
        else if (i==6)
	{
                save_format=NEXUS;
		strcat(path,".nxs");
	}

	SetTitle(savealntext, path);
}

void set_residue_exceptions(IteM i)
{
	if (residue_exceptions==FALSE)
		residue_exceptions=TRUE;
	else
		residue_exceptions=FALSE;

	draw_panel();
}
 
 
void set_fs_toggle(PopuP l)
{
        set_toggle(l,&(*opt.pw_opt).quick_pairalign);
        if ((*opt.pw_opt).quick_pairalign)
        {
                Hide(slow_para);
                Show(fast_para);
        }
        else
        {
                Hide(fast_para);
                Show(slow_para);
        }
}

void set_font_size(PopuP g)
{
        int tmp;
	char font[30];

        tmp = GetValue(g);
	font_size=tmp-1;
	sprintf(font, "%s,%d,%c", "courier", av_font[font_size], 'm');
        datafont=ParseFont(font);

	draw_panel();
	correct_name_bars(FALSE);
	correct_seq_bars(FALSE);
}
 
void set_pscroll_mode(ButtoN l)
{
	panel_data data;

        set_button(l,&fixed_prf_scroll);
	GetPanelExtra(prf_panel[0].seqs,&data);
	if(fixed_prf_scroll)
		data.lockoffset=data.firstvcol;
	else
		data.lockoffset=0;
	SetPanelExtra(prf_panel[0].seqs,&data);
	GetPanelExtra(prf_panel[1].seqs,&data);
	if(fixed_prf_scroll)
		data.lockoffset=data.firstvcol;
	else
		data.lockoffset=0;
	SetPanelExtra(prf_panel[1].seqs,&data);
	correct_seq_bars(FALSE);
}
 
void set_aln_mode(PopuP g)
{
        int tmp;
        tmp = GetValue(g);
        if (tmp == 1)
                aln_mode = MULTIPLEM;
        else
                aln_mode = PROFILEM;
        switch_mode();
}
 
void set_show_segments(PopuP l)
{
        int tmp;
        tmp = GetValue(l);
        if (tmp == 1)
                segment_exceptions=TRUE;
        else
                segment_exceptions=FALSE;
	calc_seg_exceptions();
        show_segment_exceptions();
}
 

void shift(Handle a, int dx, int dy)
{
	PoinT pt;
 
	GetNextPosition (a, &pt);
	pt.x+=dx;
	pt.y+=dy;
	SetNextPosition(a, pt);
}

void stripspace(char *str)
{
	register int i,j,p;
	char *tstr;
 
#ifndef UNIX
	return;
#endif
        p = strlen(str) - 1;
 
        while ( isspace(str[p]) )
                p--;
 
        str[p + 1] = EOS;

	tstr=(char *)ckalloc((p+2)*sizeof(char));
 
	for(i=0,j=0;i<=p;i++)
		if(!isspace(str[i]))
			tstr[j++]=str[i];
	tstr[j] = EOS;
	strcpy(str,tstr);
	ckfree(tstr);

}

void set_inverted(IteM i)
{
        inverted=GetStatus(i);
        if (inverted==FALSE)
		init_inverted("BLACK",0.4,0.4,0.4);
        else
		init_inverted("WHITE",1.0,1.0,1.0);
        draw_panel();
}


